// CountWordsCmd.h - count frequency of words in command

#ifndef COUNTWORDSCMD_H
#define COUNTWORDSCMD_H

#include <string.h>
#include <stdio.h>
#include <BreakCmd.h>
#include <List.h>

#define BUFSIZE 1024

// This class stores a string and maintains a count for word occurrence frequency

class Word
{
	public:
		Word ( char *str ) { _word = XtNewString ( str ); _count = 1; }
		~Word() { XtFree ( _word ); }
	
		// compare string in object to other string
		int operator== ( char *str ) { return ( !strcmp ( _word, str ) ); }
	
		// increment count for word
		void incrementCount() { _count++; }
		char *word() { return ( _word ); }
		int count() { return ( _count ); }

	private:
		char *_word;
		int _count;
};


class CountWordsCmd : public BreakCmd
{
	public:
		CountWordsCmd ( char *, int, char * );
		virtual ~CountWordsCmd();
		int numWords() { return ( _list.Count() ); }
		char *getWord ( int i ) { return ( _list[i]->word() ); }
		int getCount ( int i ) { return ( _list[i]->count() ); }

	
	protected:
		void doCommand();
		
	private:
		List<Word *> _list;
		long _fileSize;
		long _bytesRead;
		FILE *_fd;
		int _percentDone;
		void saveWord ( char * );	// add word to _list
	};

#endif
	
